#! /usr/bin/python3
#
#################################################################
#
# Lesen von Fileinhalt und transfer auf socket

import socketserver, socket, serial
import threading, queue
import time, os


class csocket():
    """class 'csocket', create object to connect socket
       using ip_address and port_number.
    """
    def __init__(self):
        self._ip_address ="pi3"
        self._port_number=10000

        self._socket=None

        try:
            self._socket=socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self._socket.connect((self._ip_address, self._port_number))
            print("connected to server:'{0}';port:'{1}'".format(self._ip_address, self._port_number))
        except:
            print("cht_socket_client.__init__();error:can't connect to socket")
            raise

    def __del__(self):
        if self._socket != None:
            self._socket.close()
            print("Close connection to server:'{0}';port:'{1}'".format(self._ip_address, self._port_number))

    def run(self):
        try:
            print("Client-ID:{0}; cht_socket_client run".format(self._clientID))
            while True:
                antwort=self._socket.recv(1)
                print("{0}".format(antwort))
        except:
            self._socket.close()
            print("cht_socket_client.run(); error on socket.recv")
            raise

    def close(self):
        if self._socket != None:
            self._socket.close()
            self._socket = None
            print("socket closed")

    def read(self, size=1):
        """Read size bytes from the connected socket. It will block
           until the requested number of bytes are read.
        """
        if self._socket==None:
            raise ("Client-ID:{0}; cht_socket_client.read(); error:socket not initialised".format(self._clientID))
        read=bytearray()
        while len(read) < size:
            try:
                buffer=self._socket.recv(size)
            except:
                self._socket.close()
                print("cht_socket_client.read(); error on socket.recv")
                raise

            if not buffer:
                self._socket.close()
                print("cht_socket_client.read(); peer closed socket")
                raise
            else:
                read.extend(buffer)

        return bytes(read)

    def write(self, data):
        """write data to connected socket. It will block
           until all data is written.
        """
        if self._socket==None:
            print("cht_socket_client.write(); socket not initialised")
            raise
        try:
            self._socket.sendall(bytes(data))
        except:
            print("cht_socket_client.write(); error on socket.sendall")
            raise


################################################

if __name__ == "__main__":
    import time

    print("-- start socket.client --")
    client=csocket()
    time.sleep(1)
    # data-stream send to ht_transceifer_if: '#' ,'!' ,'S',option, length(payload)
    #   data = [0x23,0x21,0x53,0,0]
    # data-stream to be send on socket : '#' , <length> ,'!' ,'S',option

    print("-- cylic send WW command to IF --")
    ww_command = [0x88,0,0x34,0,0x32,1,0xde,1,0xd0,0xa1,0,0,3,0,0,0xb4,0xa3,0,0xb,0x2a,0,0x7e,0]

    while True:
        print("command: {0} send".format(ww_command, "02x"))
        client.write(ww_command)
        time.sleep(4)
